#include <Key.h>
#include "U8glib.h"
//#include <SoftPWM.h>
//#include <SoftPWM_timer.h>
#include <Keypad.h>
char holdKey;
unsigned long t_hold;
const byte ROWS = 5; //four rows
const byte COLS = 5; //four columns

// mapped to MCS2000 control head custom PC board layout per V2A design file

char keys[ROWS][COLS] = {
  {
    '1','2','3','A','B'                                                        }
  ,
  {
    '4','5','6','C','D'                                                        }
  ,   // z in place of F4 due to conflicts in compiler
  {
    '7','8','9','E','F'                                                        }
  , // f_three in place of Fthree due to confilcts in compiler
  {
    '*','0','#','G','H'                                                        }
  ,
  {
    'I', 'J', 'K', 'L', 'M'                                             }
};

// mapped to MCS2000 control head
//char keys[ROWS][COLS] = {
//  {
//    '1','2','3','MENU','MORE'                                    }
//  ,
//  {
//    '4','5','6','Pesc','z'                                    }
//  ,   // z in place of F4 due to conflicts in compiler
//  {
//    '7','8','9','Enter','(f_three)'                                    }
//  , // f_three in place of Fthree due to confilcts in compiler
//  {
//    '*','0','#','SQL','Ftwo'                                    }
//  ,
//  {
//    'Fone', 'upperSb', 'LowerSB', 'arrowDown', 'arrowuP'                                    }
//};

byte colPins[COLS] = {
  2, 3, 4, 5, 6}; //connect to the column pinouts of the keypad
byte rowPins[ROWS] = {
  7, 8, A1, A2, A3}; //connect to the row pinouts of the keypad 7,8, A1, A2, A3
Keypad keypad = Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS );

const int sensorMin = 0;      // volume minimum
const int sensorMax = 1023; // volume maximum

#define topNotch_width 15
#define topNotch_height 25
static unsigned char topNotch_bits[] U8G_PROGMEM = {
  0xff, 0x7f, 0xff, 0x7f, 0xff, 0x7f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00
};
#define rightNotch_width 15
#define rightNotch_height 25
static unsigned char rightNotch_bits[] U8G_PROGMEM = {
  0xc7, 0x7f, 0xc7, 0x7f, 0xc7, 0x7f, 0xc7, 0x01, 0xc7, 0x01, 0xc7, 0x01,
  0xc7, 0x01, 0xc7, 0x01, 0xc7, 0x01, 0xc7, 0x01, 0xc7, 0x01, 0xc7, 0x01,
  0xc7, 0x01, 0xc7, 0x01, 0xc7, 0x01, 0xc7, 0x01, 0xc7, 0x01, 0xc7, 0x01,
  0xc7, 0x01, 0xc7, 0x01, 0xc7, 0x01, 0xc7, 0x01, 0xff, 0x01, 0xff, 0x01,
  0xff, 0x01
};
#define leftNotch_width 15
#define leftNotch_height 25
static unsigned char leftNotch_bits[] U8G_PROGMEM = {
  0xff, 0x71, 0xff, 0x71, 0xff, 0x71, 0xc0, 0x71, 0xc0, 0x71, 0xc0, 0x71,
  0xc0, 0x71, 0xc0, 0x71, 0xc0, 0x71, 0xc0, 0x71, 0xc0, 0x71, 0xc0, 0x71,
  0xc0, 0x71, 0xc0, 0x71, 0xc0, 0x71, 0xc0, 0x71, 0xc0, 0x71, 0xc0, 0x71,
  0xc0, 0x71, 0xc0, 0x71, 0xc0, 0x71, 0xc0, 0x71, 0xc0, 0x7f, 0xc0, 0x7f,
  0xc0, 0x7f
};
#define clarifier_width 30
#define clarifier_height 14
static unsigned char clarifier_bits[] U8G_PROGMEM = {
  0xfc, 0xff, 0xff, 0x0f, 0x02, 0x40, 0x00, 0x10, 0x01, 0x42, 0x08, 0x20,
  0x01, 0x46, 0x0c, 0x20, 0x01, 0x4e, 0x0e, 0x20, 0xf1, 0x5f, 0xff, 0x23,
  0xf1, 0xff, 0xff, 0x23, 0xf1, 0x5f, 0xff, 0x23, 0xf1, 0x4f, 0xfe, 0x23,
  0x01, 0x46, 0x0c, 0x20, 0x01, 0x42, 0x08, 0x20, 0x01, 0x40, 0x00, 0x20,
  0x02, 0x40, 0x00, 0x10, 0xfc, 0xff, 0xff, 0x0f
};
#define squelch_width 30
#define squelch_height 14
static unsigned char squelch_bits[] U8G_PROGMEM = {
  0xfc, 0xff, 0xff, 0x0f, 0x02, 0x00, 0x80, 0x11, 0x61, 0x08, 0xe0, 0x27,
  0x41, 0x10, 0x31, 0x26, 0x81, 0x20, 0x02, 0x2c, 0x01, 0x61, 0x44, 0x2c,
  0x01, 0xc3, 0x8c, 0x2c, 0x01, 0xc3, 0x8c, 0x2c, 0x01, 0x61, 0x44, 0x24,
  0x81, 0x20, 0x02, 0x26, 0x41, 0x10, 0x31, 0x23, 0x31, 0x08, 0xe0, 0x21,
  0x02, 0x00, 0x00, 0x10, 0xfc, 0xff, 0xff, 0x0f
};
#define noiseBlanker_width 30
#define noiseBlanker_height 14
static unsigned char noiseBlanker_bits[] U8G_PROGMEM = {
  0xfc, 0xff, 0xff, 0x0f, 0x02, 0x06, 0x80, 0x10, 0x41, 0x0c, 0xc1, 0x21,
  0xe1, 0x98, 0x43, 0x21, 0xa7, 0xb0, 0x46, 0x21, 0xad, 0xf8, 0x44, 0x3b,
  0xa9, 0xc9, 0x6c, 0x2a, 0x29, 0x8d, 0x29, 0x2a, 0x39, 0x05, 0x3b, 0x2e,
  0x39, 0x07, 0x16, 0x2e, 0x11, 0x07, 0x0c, 0x24, 0x01, 0x02, 0x18, 0x20,
  0x02, 0x00, 0x30, 0x10, 0xfc, 0xff, 0xff, 0x0f
};
#define notchFilter_width 30
#define notchFilter_height 14
static unsigned char notchFilter_bits[] U8G_PROGMEM = {
  0xfc, 0xff, 0xff, 0x0f, 0x02, 0x00, 0x00, 0x10, 0x01, 0x0f, 0x78, 0x20,
  0x81, 0x1f, 0xfc, 0x20, 0xc1, 0x39, 0xce, 0x21, 0xc1, 0x30, 0x86, 0x21,
  0xc1, 0x70, 0x87, 0x21, 0xc1, 0x60, 0x83, 0x21, 0xc1, 0xe0, 0x83, 0x21,
  0xc1, 0xc0, 0x81, 0x21, 0xe1, 0xc0, 0x81, 0x23, 0x71, 0x80, 0x00, 0x27,
  0x02, 0x00, 0x00, 0x10, 0xfc, 0xff, 0xff, 0x0f
};
#define LSB_width 30
#define LSB_height 14
static unsigned char LSB_bits[] U8G_PROGMEM = {
  0xfc, 0xff, 0xff, 0x0f, 0x02, 0x00, 0x00, 0x10, 0xf9, 0xff, 0xcf, 0x20,
  0xe9, 0x21, 0xcc, 0x20, 0xe9, 0xbe, 0xcb, 0x20, 0xe9, 0x31, 0xcc, 0x20,
  0xe9, 0xaf, 0xcb, 0x20, 0x89, 0x30, 0xcc, 0x20, 0xf9, 0xff, 0xcf, 0x20,
  0x01, 0x00, 0xc0, 0x20, 0xf9, 0xff, 0xff, 0x27, 0xf9, 0xff, 0xff, 0x27,
  0x02, 0x00, 0x00, 0x10, 0xfc, 0xff, 0xff, 0x0f
};
#define USB_width 30
#define USB_height 14
static unsigned char USB_bits[] U8G_PROGMEM = {
  0xfc, 0xff, 0xff, 0x0f, 0x02, 0x00, 0x00, 0x10, 0xc1, 0xfc, 0xff, 0x23,
  0xc1, 0xb4, 0x11, 0x23, 0xc1, 0xb4, 0xde, 0x22, 0xc1, 0xb4, 0x19, 0x23,
  0xc1, 0xb4, 0xd7, 0x22, 0xc1, 0xcc, 0x18, 0x23, 0xc1, 0xfc, 0xff, 0x23,
  0xc1, 0x00, 0x00, 0x20, 0xf9, 0xff, 0xff, 0x23, 0xf9, 0xff, 0xff, 0x23,
  0x02, 0x00, 0x00, 0x10, 0xfc, 0xff, 0xff, 0x0f
};
#define AGC_width 30
#define AGC_height 14
static unsigned char AGC_bits[] U8G_PROGMEM = {
  0xfc, 0xff, 0xff, 0x0f, 0x02, 0x00, 0x00, 0x10, 0x01, 0x00, 0x00, 0x20,
  0x79, 0x38, 0x8e, 0x23, 0x09, 0x44, 0x41, 0x20, 0x09, 0x44, 0x41, 0x20,
  0x39, 0x44, 0x41, 0x20, 0x89, 0x7d, 0x4d, 0x20, 0x09, 0x44, 0x51, 0x20,
  0x09, 0x44, 0x51, 0x20, 0x09, 0x44, 0x8e, 0x23, 0x41, 0x80, 0x10, 0x24,
  0x02, 0x00, 0x00, 0x10, 0xfc, 0xff, 0xff, 0x0f
};
#define stack_width 30
#define stack_height 14
static unsigned char stack_bits[] U8G_PROGMEM = {
  0xfc, 0xff, 0xff, 0x0f, 0x02, 0x00, 0x00, 0x10, 0x81, 0x44, 0x24, 0x20,
  0x01, 0x09, 0x12, 0x20, 0x11, 0xf2, 0x09, 0x21, 0x21, 0xfc, 0x87, 0x20,
  0x41, 0xfc, 0x47, 0x20, 0x85, 0xfe, 0x2f, 0x24, 0x11, 0xfe, 0x0f, 0x21,
  0x41, 0xff, 0x5f, 0x20, 0x01, 0xff, 0x1f, 0x20, 0x01, 0xfe, 0x0f, 0x20,
  0x02, 0x00, 0x00, 0x10, 0xfc, 0xff, 0xff, 0x0f
};
#define mute_width 30
#define mute_height 14
static unsigned char mute_bits[] U8G_PROGMEM = {
  0xfc, 0xff, 0xff, 0x0f, 0x02, 0xc0, 0x00, 0x10, 0x11, 0x9c, 0x01, 0x20,
  0x89, 0x34, 0x03, 0x20, 0x45, 0x64, 0x06, 0x20, 0x25, 0xc4, 0xff, 0x21,
  0x25, 0x05, 0x18, 0x21, 0x25, 0x05, 0x30, 0x21, 0x25, 0xc4, 0xff, 0x21,
  0x45, 0x64, 0xc0, 0x20, 0x89, 0x34, 0x80, 0x21, 0x11, 0x1c, 0x00, 0x23,
  0x02, 0x00, 0x00, 0x16, 0xfc, 0xff, 0xff, 0x0f };
#define more_width 6
#define more_height 11
static unsigned char more_bits[] U8G_PROGMEM = {
  0x01, 0x03, 0x07, 0x0f, 0x1f, 0x3f, 0x1f, 0x0f, 0x07, 0x03, 0x01 };
//U8GLIB_NHD31OLED_GR u8g(46, 48);  // SPI Com: SCK = 13, MOSI = 11, CS = 10, A0 = 9
//U8GLIB_NHD31OLED_GR u8g(13,11,10,9);
U8GLIB_NHD31OLED_2X_GR u8g(10,9);
byte rssiCounter;
char rxdata[40];
char checkSumVal;
char checkSumByte;
char softButtons[16];
char freqLine[20];
char aleLine[20];
char menuLine[6];
char soft1[5];
char soft2[5];
char soft3[5];
char soft4[5];
char first;
char sum=0;
char length;
char usbIndication[4];
char ALEscan;
char aleNET[6];
char RSSIlevel[8];
char ale;
byte opCode;
byte subopCode;
byte endMarker;
byte volumeVar = 0x00;
byte previousvolume;
byte a;//int
byte b; //int
byte i;  //int
byte j; //int
byte m; //int
byte n; //int
byte index; //int
byte pttState = 0; //int
long previousMillis = 0;
long previousMillisReports = 0;
long interval = 3000; //volume indication fade out time
unsigned long time;
boolean squelchLogic;
boolean aleBool = false;
boolean pttLogic = false;
boolean packetRead = false;
boolean ALEactive = false;

//Control data strings
byte squelchOff[8] = {
  0x24,0x03,0x18,0x09,0x00,0x00,0x48,0x03};
byte squelchOn[8] = {
  0x24,0x03,0x18,0x09,0x00,0x01,0x49,0x03};
byte volume[8] =  {
  0x24,0x03,0x18,0x2B,0x00,0x00,0x6A,0x03}; // volume level 0 in hex
byte reportVol[7] = {
  0x24,0x01,0x18,0x2C,0x69,0x03};
byte button1[10] = {
  0x24,0x05,0x18,0x36,0xFF,0x79,0xEF,0x01,0xDF,0x03}; // keypad button 1
byte button2[10] = {
  0x24,0x05,0x18,0x36,0xFF,0x3B,0xEF,0x01,0xA1,0x03}; // keypad button 2
byte button3[10] = {
  0x24,0x05,0x18,0x36,0xFF,0x7B,0xE7,0x01,0xD9,0x03}; // keypad button 3
byte button4[10] = {
  0x24,0x05,0x18,0x36,0xFF,0x5B,0xEF,0x01,0xC1,0x03}; // keypad button 4
byte button5[10] = {
  0x24,0x05,0x18,0x36,0xFF,0x7B,0xEB,0x01,0xDD,0x03}; // keypad button 5
byte button6[10] = {
  0x24,0x05,0x18,0x36,0xFF,0x7B,0x6F,0x01,0x61,0x03}; // keypad button 6
byte button7[10] = {
  0x24,0x05,0x18,0x36,0xFF,0x7B,0xAF,0x01,0xA1,0x03}; // keypad button 7
byte button8[10] = {
  0x24,0x05,0x18,0x36,0xF7,0x7B,0xEF,0x01,0xD9,0x03}; // keypad button 8
byte button9[10] = {
  0x24,0x05,0x18,0x36,0xFF,0x7A,0xEF,0x01,0xE0,0x03}; // keypad button 9
byte button0[10] = {
  0x24,0x05,0x18,0x36,0x7F,0x7B,0xEF,0x01,0x61,0x03}; // keypad button 0
byte buttonAsterisk[10] = {
  0x24,0x05,0x18,0x36,0xFB,0x7B,0xEF,0x01,0xDD,0x03}; // keypad button *
byte buttonPound[10] = {
  0x24,0x05,0x18,0x36,0xFF,0x6B,0xEF,0x01,0xD1,0x03}; // keypad button #
byte buttonMENU[10] = {
  0x24,0x05,0x18,0x36,0xFF,0x7B,0xEF,0x00,0xE0,0x03}; // keypad button MENU
byte buttonPesc[10] = {
  0x24,0x05,0x18,0x36,0xEF,0x7B,0xEF,0x01,0xD1,0x03}; // keypad button Pesc
byte buttonEnter[10] = {
  0x24,0x05,0x18,0x36,0xFF,0x7B,0xED,0x01,0xDF,0x03}; // keypad button Enter
byte moreKey[10] = {
  0x24,0x05,0x18,0x36,0xFD,0x7B,0xEF,0x01,0xDF,0x03};  // more key
byte fOneKey[10] = {
  0x24,0x05,0x18,0x36,0xBF,0x7B,0xEF,0x01,0xA1,0x03};  // soft key F1
byte fTwoKey[10] = {
  0x24,0x05,0x18,0x36,0xFF,0x73,0xEF,0x01,0xD9,0x03};  // soft key F2
byte fThreeKey[10] = {
  0x24,0x05,0x18,0x36,0xFF,0x7B,0xEE,0x01,0xE0,0x03};  //soft key F3
byte fFourKey[10] = {
  0x24,0x05,0x18,0x36,0xFF,0x7B,0xCF,0x01,0xc1,0x03};  // soft key F4
byte buttonRelease[10] = {
  0x24,0x05,0x18,0x36,0xFF,0x7B,0xEF,0x01,0xE1,0x03}; // button release command
byte arrowUp[10] = {
  0x24,0x05,0x18,0x36,0xFE,0x7B,0xEF,0x01,0xE0,0x03}; // up button command
byte arrowDown[10] = {
  0x24,0x05,0x18,0x36,0xDF,0x7B,0xEF,0x01,0xC1,0x03}; // down button command
byte lsb[8] = {
  0x24,0x03,0x18,0x03,0x00,0x00,0x42,0x03};
byte usb[8] = {
  0x24,0x03,0x18,0x03,0x00,0x01,0x43,0x03};
byte specialReports[9] = {
  0x24,0x04,0x18,0x29,0x00,0x01,0x2E,0x98,0x03};  // enable special reports
byte pttEngage[7] = {
  0x24, 0x02, 0x81, 0x13, 0x01, 0xBB, 0x03};
byte pttRelease[7] = {
  0x24, 0x02, 0x81, 0x14, 0x01, 0xBC, 0x03};
byte acknowledge[6] = {
  0x24,0x01,0x10,0xF3,0x28,0x03}; // ack to radio from head
byte radioack[6] = {
  0x24,0x01,0x80,0xF3,0x98,0x03};  // ack from radio to head
byte txLed;
byte remoteLed;
byte icons;
byte upperSB;
byte squelch;
byte noiseBlanker;
byte notchFilter;
byte fastAGC;
byte lowerSB;
byte mute;
byte clarifier;
byte narFilter;
byte stack;
byte more;
byte leftNotch;
byte rightNotch;
byte topLine;
byte  barOne = 0;
byte  barTwo = 0;
byte  barThree = 0;
byte  barFour = 0;
byte  barFive = 0;
byte  barSix = 0;
byte  barSeven = 0;
byte  barEight = 0;
byte  barNine = 0;
byte  barTen = 0;

void setup(void) {
  Serial.begin(9600, SERIAL_8O1);
  Serial.write(specialReports, 9);
  //SoftPWMBegin();
  //SoftPWMSet(A5, 0);
  // pinMode(12, INPUT_PULLUP);
  // pinMode(pttSense, INPUT);
  keypad.setHoldTime(500);
  keypad.setDebounceTime(30); 
  keypad.addEventListener(keypadEvent); 
  // assign default color value
  if ( u8g.getMode() == U8G_MODE_R3G3B2 ) {
    u8g.setColorIndex(255);     // white
  }
  else if ( u8g.getMode() == U8G_MODE_GRAY2BIT ) {
    u8g.setColorIndex(3);         // max intensity
  }
  else if ( u8g.getMode() == U8G_MODE_BW ) {
    u8g.setColorIndex(1);         // pixel on
  }
  else if ( u8g.getMode() == U8G_MODE_HICOLOR ) {
    u8g.setHiColorByRGB(255,255,255);
  }
}
void loop() {

  char key = keypad.getKey();


  //SoftPWMSetPercent(A5, 100); // keypad brightness control
  if (Serial.available() != 0) {
    delay(3);
    first = Serial.read();
    if (first == 0x24) {
      length = Serial.read();
    }
    a = length + 3;    //1
    rxdata[a];
    //delay(20);
    for (i=0;i<a;i++) {  // read the entire packet into rxdata
      rxdata[i] = Serial.read();
      rxdata[i+1] = '\0';
    }
    endMarker = rxdata[a-1];
    opCode = rxdata[1];
    subopCode = rxdata[2];
    if (first == 0x24 && opCode != 0xF3){
      packetRead = true;  
      Serial.write(acknowledge, 6);  
      first = 0x00;
    }
  }
  //---------------------Top Line / CHAN (LINE0)--------------------------
  if (opCode == 0x2E && subopCode == 0x02)
  {
    //EXAMPLE MENU PACKET 24 09 81 2E 02 02 55 4D 45 4E 55 20 8A 03 (display 0, 0)
    for(int i=5, j=0; i<=9; i++, j++) { // 5, 9
      menuLine[j] = rxdata[i];
      menuLine[j+1] = '\0';                
    }
  }
  //---------------------------Main Center Text (LINE2)-------------------------------
  if (opCode == 0x2E && subopCode == 0x03)
  {
    //EXAMPLE FREQUENCY PACKET 24 0F 81 2E 03 02 6E 46 20 20 38 2C 39 39 32 2E 39 38 82 03 (display 0, 1)
    for(int i=5, j=0; i<=15; i++, j++) {
      freqLine[j] = rxdata[i];
      freqLine[j+1] = '\0';
    }
  }

  // ---------------------Soft Buttons  (LINE3)-------------------------
  if (opCode == 0x2E && subopCode == 0x04)
  {
    for(int i=5, j=0; i<=19; i++, j++) {  //19
      softButtons[j] = rxdata[i];
      softButtons[j+1] = '\0';
      soft1[0] = softButtons[0]; // soft button spacing
      soft1[1] = softButtons[1];
      soft1[2] = softButtons[2];
      soft1[3] = softButtons[3];
      soft2[0] = softButtons[4];
      soft2[1] = softButtons[5];
      soft2[2] = softButtons[6];
      soft2[3] = softButtons[7];
      soft3[0] = softButtons[8];
      soft3[1] = softButtons[9];
      soft3[2] = softButtons[10];
      soft3[3] = softButtons[11];
      soft4[0] = softButtons[12];
      soft4[1] = softButtons[13];
      soft4[2] = softButtons[14];
      soft4[3] = softButtons[15];
    }
  }

  //-------------------------ICONS----------------------------------
  if (opCode == 0x2E && subopCode == 0x05)
  {
    upperSB = bitRead(rxdata[4], 7);
    squelch = bitRead(rxdata[4], 5);
    noiseBlanker = bitRead(rxdata[4], 3);
    notchFilter = bitRead(rxdata[4], 1);
    fastAGC = bitRead(rxdata[5], 7);
    lowerSB = bitRead(rxdata[5], 5);
    mute = bitRead(rxdata[5], 3); //monitoring is off
    clarifier = bitRead(rxdata[5], 1);
    narFilter = bitRead(rxdata[6], 7);
    stack = bitRead(rxdata[6], 5);
    more = bitRead(rxdata[6], 3);
    // upper side band icon  -----------
  }
  //------------------------------RSSI-------------------------------------------
  RSSIlevel[4] = rxdata[4];
  RSSIlevel[5] = rxdata[5];
  ale = rxdata[4];


  //-----------------------------------ANALOG VOLUME---------------------------
//   analog volume comment out here on down if keypad volume is used
  unsigned long currentMillis = millis();
   int sensorReading = analogRead(A0);   // map the sensor range, Micom goes from 0x00 to 0xFF
   int range = map(sensorReading, sensorMin, sensorMax, 0, 255);
   volumeVar = range;
   volume[4] = volumeVar;
   volume[6] = volumeVar + 0x6A;
   if (previousvolume < range-1 || previousvolume > range+1) {
     Serial.write(volume, 8);
     previousvolume = volumeVar;
   }  
  u8g.firstPage(); 
  do {        
    draw();
  }
  while( u8g.nextPage() );

}

void draw(void)  //--------------------------DRAW--------------------------------
{

  if (freqLine[3] == 0x04) {
    u8g.drawXBMP( 70, 20, topNotch_width, topNotch_height, topNotch_bits);
  }
  if (freqLine[3] == 0x05) {
    u8g.drawXBMP( 70, 20, rightNotch_width, rightNotch_height, rightNotch_bits);
  }
  if (freqLine[3] == 0x06) {
    u8g.drawXBMP( 70, 20, leftNotch_width, leftNotch_height, leftNotch_bits);
  }
  if (freqLine[4] == 0x04) {
    u8g.drawXBMP( 85, 20, topNotch_width, topNotch_height, topNotch_bits);
  }
  if (freqLine[4] == 0x05) {
    u8g.drawXBMP( 85, 20, rightNotch_width, rightNotch_height, rightNotch_bits);
  }
  if (freqLine[4] == 0x06) {
    u8g.drawXBMP( 85, 20, leftNotch_width, leftNotch_height, leftNotch_bits);
  }
  if (freqLine[5] == 0x04) {
    u8g.drawXBMP( 100, 20, topNotch_width, topNotch_height, topNotch_bits);
  }
  if (freqLine[5] == 0x05) {
    u8g.drawXBMP( 100, 20, rightNotch_width, rightNotch_height, rightNotch_bits);
  }
  if (freqLine[5] == 0x06) {
    u8g.drawXBMP( 100, 20, leftNotch_width, leftNotch_height, leftNotch_bits);
  }
  if (freqLine[6] == 0x04) {
    u8g.drawXBMP( 115, 20, topNotch_width, topNotch_height, topNotch_bits);
  }
  if (freqLine[6] == 0x05) {
    u8g.drawXBMP( 115, 20, rightNotch_width, rightNotch_height, rightNotch_bits);
  }
  if (freqLine[6] == 0x06) {
    u8g.drawXBMP( 115, 20, leftNotch_width, leftNotch_height, leftNotch_bits);
  }
  if (freqLine[7] == 0x04) {
    u8g.drawXBMP( 130, 20, topNotch_width, topNotch_height, topNotch_bits);
  }
  if (freqLine[7] == 0x05) {
    u8g.drawXBMP( 130, 20, rightNotch_width, rightNotch_height, rightNotch_bits);
  }
  if (freqLine[7] == 0x06) {
    u8g.drawXBMP( 130, 20, leftNotch_width, leftNotch_height, leftNotch_bits);
  }
  if (opCode == 0x2E && subopCode == 0x0D)      //----------------ALE scan
  {
    ALEactive = true;
    byte disp;
  }
  else
    ALEactive = false;
  u8g.setFont(u8g_font_fur11r);
  u8g.drawStr( 0, 12, menuLine);
  if (ALEactive == true) {
    u8g.setColorIndex(0);
    u8g.setFont(u8g_font_fub25r);
    u8g.drawStr( 0, 45, freqLine);
    aleNET[0] = freqLine[0];
    aleNET[1] = freqLine[1];
    aleNET[2] = freqLine[2];
    aleNET[3] = freqLine[3];
    aleNET[4] = freqLine[4];
    aleNET[5] = freqLine[5];
    u8g.setColorIndex(3);
    u8g.setFont(u8g_font_fub25r);
    u8g.setPrintPos(0,45);
    u8g.print(aleNET);
    u8g.setFont(u8g_font_fub25r);
    u8g.setPrintPos(148,45);
    u8g.print(ale, DEC);
  }
  if (ALEactive == false) {



    u8g.setColorIndex(3);
    u8g.setFont(u8g_font_fub25r);
    u8g.drawStr( 0, 45, freqLine);


  }
  u8g.setColorIndex(3);
  u8g.setFont(u8g_font_fur11r);
  u8g.drawStr( 25, 64, soft1);
  u8g.drawStr( 77, 64, soft2);
  u8g.drawStr( 137, 64, soft3);
  u8g.drawStr( 188, 64, soft4);
  u8g.setFont(u8g_font_fur11r);
  if (mute == 1) {
    u8g.drawXBMP(218, 0, mute_width, mute_height, mute_bits); // monitoring is off
  }
  else
    if (upperSB == 1) {
      u8g.drawXBMP( 218, 0, USB_width, USB_height, USB_bits);
      //u8g.drawStr( 218, 12, "USB");
    }
    else
      if (lowerSB == 1) {
        u8g.drawXBMP( 218, 0, LSB_width, LSB_height, LSB_bits);
        // u8g.drawStr( 218, 12, "LSB");
      }
  if (squelch == 1) {
    u8g.setFont(u8g_font_fur11r);         //u8g_font_7x13
    u8g.drawXBMP(186, 0, squelch_width, squelch_height, squelch_bits);
    //u8g.drawStr(190, 12, "SQ");
  }

  if (noiseBlanker == 1) {
    u8g.setFont(u8g_font_fur11r);             //u8g_font_7x13
    u8g.drawXBMP(154, 0, noiseBlanker_width, noiseBlanker_height, noiseBlanker_bits);
    //u8g.drawStr( 160, 12, "NB");
  }

  if (notchFilter == 1) {
    u8g.setFont(u8g_font_fur11r);              //u8g_font_7x13
    u8g.drawXBMP(122, 0, notchFilter_width, notchFilter_height, notchFilter_bits);
    //u8g.drawStr( 125, 12, "N.F.");
  }

  if (fastAGC == 1) {
    u8g.drawXBMP(90, 0, AGC_width, AGC_height, AGC_bits);
  }

  if (stack == 1) {
    u8g.drawXBMP(58, 0, stack_width, stack_height, stack_bits);
  }
  if (more == 1) {
    u8g.drawXBMP(220, 53, more_width, more_height, more_bits);
  }

  if (clarifier == 1) {
    u8g.drawXBMP(186, 16, clarifier_width, clarifier_height, clarifier_bits);
  }
  if (opCode == 0x2E && subopCode == 0x06)
  {
    u8g.setFont(u8g_font_timR08);
    u8g.setPrintPos(243,64);
    u8g.print(rssiCounter);
    barOne = bitRead(RSSIlevel[5], 0);
    barTwo = bitRead(RSSIlevel[5], 1);
    barThree = bitRead(RSSIlevel[5], 2);
    barFour = bitRead(RSSIlevel[5], 3);
    barFive = bitRead(RSSIlevel[5], 4);
    barSix = bitRead(RSSIlevel[5], 5);
    barSeven = bitRead(RSSIlevel[5], 6);
    barEight = bitRead(RSSIlevel[5], 7);
    barNine = bitRead(RSSIlevel[5], 8);
    barTen = bitRead(RSSIlevel[4], 1);
    u8g.setFont(u8g_font_fub25r);
    if (barOne == 1){
      u8g.setPrintPos(240,50);
      u8g.setColorIndex(1);
      u8g.print(".");
      rssiCounter = 0x01;
    }
    if (barTwo == 1){
      u8g.setPrintPos(240,47);
      u8g.setColorIndex(1);
      u8g.print(".");
      rssiCounter = 0x02;
    }
    if (barThree == 1){
      u8g.setPrintPos(240,44);
      u8g.setColorIndex(1);
      u8g.print(".");
      rssiCounter = 0x03;

    }
    if (barFour == 1){
      u8g.setPrintPos(240,41);
      u8g.setColorIndex(2);
      u8g.print(".");
      rssiCounter = 0x04;
    }
    if (barFive == 1){
      u8g.setPrintPos(240,38);
      u8g.setColorIndex(2);
      u8g.print(".");
      rssiCounter = 0x05;
    }
    if (barSix == 1){
      u8g.setPrintPos(240,35);
      u8g.setColorIndex(2);
      u8g.print(".");
      rssiCounter = 0x06;
    }
    if (barSeven == 1){
      u8g.setPrintPos(240,32);
      u8g.setColorIndex(3);
      u8g.print(".");
      rssiCounter = 0x07;
    }
    if (barEight == 1){
      u8g.setPrintPos(240,29);
      u8g.setColorIndex(3);
      u8g.print(".");
      rssiCounter = 0x08;
    }
    if (barNine == 1){
      u8g.setPrintPos(240,26);
      u8g.setColorIndex(3);
      u8g.print(".");
      rssiCounter = 0x09;
    }
    if (barTen == 1 && barOne == 0) {
      u8g.setPrintPos(240,23);
      u8g.setColorIndex(3);
      u8g.print(".");
      u8g.setPrintPos(230,23);
      rssiCounter = '+';
    }
  }
  u8g.setColorIndex(3);
  u8g.setFont(u8g_font_timR08);
  u8g.setPrintPos(0,64);
  u8g.print("V");
  u8g.setPrintPos(10,64);
  u8g.print(volumeVar);
//  u8g.setPrintPos(10,64);
//  u8g.print(kkeeyy);
//
//  u8g.setPrintPos(30,64);
//  u8g.print("*");
  
  u8g.setColorIndex(3);
  //---------------------------------------------END DRAW------------------------------------

}



void keypadEvent(KeypadEvent key){

kkeeyy = key;
  switch (keypad.getState()){
  case PRESSED:
    switch (key){

    case '1':
      Serial.write(button1, 10);

      break;
    case '2':
      Serial.write(button2, 10);

      break;
    case '3':
      Serial.write(button3, 10);

      break;
    case '4':
      Serial.write(button4, 10);

      break;
    case '5':
      Serial.write(button5, 10);

      break;
    case '6':
      Serial.write(button6, 10);

      break;
    case '7':
      Serial.write(button7, 10);

      break;
    case '8':
      Serial.write(button8, 10);

      break;
    case '9':
      Serial.write(button9, 10);

      break;
    case '0':
      Serial.write(button0, 10);

      break;
    case '*':
      Serial.write(buttonAsterisk, 10);

      break;
    case '#':
      Serial.write(buttonPound, 10);

      break;
    case 'A':
      Serial.write(buttonMENU, 10);

      break;
    case 'C':
      Serial.write(buttonPesc, 10);

      break;
    case 'G':
      if (squelchLogic == false){
        Serial.write(squelchOff, 8);
        squelchLogic = true;
      }
      else
        if (squelchLogic == true) {
          Serial.write(squelchOn, 8);
          squelchLogic = false;
        }
      break;

    case 'E':
      Serial.write(buttonEnter, 10);

      break;

    case 'B':
      Serial.write(moreKey, 10);

      break;

    case 'I':
      Serial.write(fOneKey, 10);

      break;

    case 'H':
      Serial.write(fTwoKey, 10);

      break;

    case 'F':
      Serial.write(fThreeKey, 10);

      break;

    case 'D':
      Serial.write(fFourKey, 10);

      break;

    case 'M':

      Serial.write(arrowUp, 10);

      break;

    case 'L':

      Serial.write(arrowDown, 10);

      break;

    case 'K':

      Serial.write(lsb, 8);

      break;

    case 'J':
      Serial.write(usb, 8);

      break;
    }





    break;

  case RELEASED:
    switch (key){
    case '1':
      Serial.write(buttonRelease, 10);

      break;
    case '2':
      Serial.write(buttonRelease, 10);

      break;
    case '3':
      Serial.write(buttonRelease, 10);

      break;
    case '4':
      Serial.write(buttonRelease, 10);

      break;
    case '5':
      Serial.write(buttonRelease, 10);

      break;
    case '6':
      Serial.write(buttonRelease, 10);

      break;
    case '7':
      Serial.write(buttonRelease, 10);

      break;
    case '8':
      Serial.write(buttonRelease, 10);

      break;
    case '9':
      Serial.write(buttonRelease, 10);

      break;
    case '0':
      Serial.write(buttonRelease, 10);

      break;
    case '*':
      Serial.write(buttonRelease, 10);

      break;
    case '#':
      Serial.write(buttonRelease, 10);

      break;
    case 'A':
      Serial.write(buttonRelease, 10);

      break;
    case 'C':
      Serial.write(buttonRelease, 10);

      break;     

    case 'E':
      Serial.write(buttonRelease, 10);
      break;

    case 'B':
      Serial.write(buttonRelease, 10);
      break;

    case 'I':
      Serial.write(buttonRelease, 10);
      break;

    case 'H':
      Serial.write(buttonRelease, 10);
      break;

    case 'F':
      Serial.write(buttonRelease, 10);
      break;

    case 'D':
      Serial.write(buttonRelease, 10);
      break;

    case 'M':
      Serial.write(buttonRelease, 10);
      break;

    case 'L':
      Serial.write(buttonRelease, 10);
      break;

    case 'K':
      Serial.write(buttonRelease, 10);
      break;

    case 'J':
      Serial.write(buttonRelease, 10);
      break;
    }    
    break;

  case HOLD:
    switch (key){
    case 'M':

      Serial.write(arrowUp, 10);

      break;

    case 'L':

      Serial.write(arrowDown, 10);

      break;
    }
    break;
  }
}


